/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.modelflattening.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.microsoft.rest.serializer.JsonFlatten;

/**
 * Flattened product.
 */
@JsonFlatten
public class FlattenedProduct extends Resource {
    /**
     * The pname property.
     */
    @JsonProperty(value = "properties.p\\.name")
    private String pname;

    /**
     * The flattenedProductType property.
     */
    @JsonProperty(value = "properties.type")
    private String flattenedProductType;

    /**
     * Possible values include: 'Succeeded', 'Failed', 'canceled', 'Accepted',
     * 'Creating', 'Created', 'Updating', 'Updated', 'Deleting', 'Deleted',
     * 'OK'.
     */
    @JsonProperty(value = "properties.provisioningStateValues", access = JsonProperty.Access.WRITE_ONLY)
    private String provisioningStateValues;

    /**
     * The provisioningState property.
     */
    @JsonProperty(value = "properties.provisioningState")
    private String provisioningState;

    /**
     * Get the pname value.
     *
     * @return the pname value
     */
    public String pname() {
        return this.pname;
    }

    /**
     * Set the pname value.
     *
     * @param pname the pname value to set
     * @return the FlattenedProduct object itself.
     */
    public FlattenedProduct withPname(String pname) {
        this.pname = pname;
        return this;
    }

    /**
     * Get the flattenedProductType value.
     *
     * @return the flattenedProductType value
     */
    public String flattenedProductType() {
        return this.flattenedProductType;
    }

    /**
     * Set the flattenedProductType value.
     *
     * @param flattenedProductType the flattenedProductType value to set
     * @return the FlattenedProduct object itself.
     */
    public FlattenedProduct withFlattenedProductType(String flattenedProductType) {
        this.flattenedProductType = flattenedProductType;
        return this;
    }

    /**
     * Get the provisioningStateValues value.
     *
     * @return the provisioningStateValues value
     */
    public String provisioningStateValues() {
        return this.provisioningStateValues;
    }

    /**
     * Get the provisioningState value.
     *
     * @return the provisioningState value
     */
    public String provisioningState() {
        return this.provisioningState;
    }

    /**
     * Set the provisioningState value.
     *
     * @param provisioningState the provisioningState value to set
     * @return the FlattenedProduct object itself.
     */
    public FlattenedProduct withProvisioningState(String provisioningState) {
        this.provisioningState = provisioningState;
        return this;
    }

}
