/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.validation.models;

import java.util.List;
import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * The product documentation.
 */
public class Product {
    /**
     * Non required array of unique items from 0 to 6 elements.
     */
    @JsonProperty(value = "display_names")
    private List<String> displayNames;

    /**
     * Non required int betwen 0 and 100 exclusive.
     */
    private Integer capacity;

    /**
     * Image URL representing the product.
     */
    private String image;

    /**
     * The child property.
     */
    @JsonProperty(required = true)
    private ChildProduct child;

    /**
     * The constChild property.
     */
    @JsonProperty(required = true)
    private ConstantProduct constChild;

    /**
     * Constant int.
     */
    @JsonProperty(required = true)
    private int constInt;

    /**
     * Constant string.
     */
    @JsonProperty(required = true)
    private String constString;

    /**
     * Constant string as Enum. Possible values include:
     * 'constant_string_as_enum'.
     */
    private EnumConst constStringAsEnum;

    /**
     * Creates an instance of Product class.
     */
    public Product() {
        constChild = new ConstantProduct();
        constInt = 0;
        constString = "constant";
    }

    /**
     * Get the displayNames value.
     *
     * @return the displayNames value
     */
    public List<String> displayNames() {
        return this.displayNames;
    }

    /**
     * Set the displayNames value.
     *
     * @param displayNames the displayNames value to set
     * @return the Product object itself.
     */
    public Product withDisplayNames(List<String> displayNames) {
        this.displayNames = displayNames;
        return this;
    }

    /**
     * Get the capacity value.
     *
     * @return the capacity value
     */
    public Integer capacity() {
        return this.capacity;
    }

    /**
     * Set the capacity value.
     *
     * @param capacity the capacity value to set
     * @return the Product object itself.
     */
    public Product withCapacity(Integer capacity) {
        this.capacity = capacity;
        return this;
    }

    /**
     * Get the image value.
     *
     * @return the image value
     */
    public String image() {
        return this.image;
    }

    /**
     * Set the image value.
     *
     * @param image the image value to set
     * @return the Product object itself.
     */
    public Product withImage(String image) {
        this.image = image;
        return this;
    }

    /**
     * Get the child value.
     *
     * @return the child value
     */
    public ChildProduct child() {
        return this.child;
    }

    /**
     * Set the child value.
     *
     * @param child the child value to set
     * @return the Product object itself.
     */
    public Product withChild(ChildProduct child) {
        this.child = child;
        return this;
    }

    /**
     * Get the constChild value.
     *
     * @return the constChild value
     */
    public ConstantProduct constChild() {
        return this.constChild;
    }

    /**
     * Set the constChild value.
     *
     * @param constChild the constChild value to set
     * @return the Product object itself.
     */
    public Product withConstChild(ConstantProduct constChild) {
        this.constChild = constChild;
        return this;
    }

    /**
     * Get the constInt value.
     *
     * @return the constInt value
     */
    public int constInt() {
        return this.constInt;
    }

    /**
     * Set the constInt value.
     *
     * @param constInt the constInt value to set
     * @return the Product object itself.
     */
    public Product withConstInt(int constInt) {
        this.constInt = constInt;
        return this;
    }

    /**
     * Get the constString value.
     *
     * @return the constString value
     */
    public String constString() {
        return this.constString;
    }

    /**
     * Set the constString value.
     *
     * @param constString the constString value to set
     * @return the Product object itself.
     */
    public Product withConstString(String constString) {
        this.constString = constString;
        return this;
    }

    /**
     * Get the constStringAsEnum value.
     *
     * @return the constStringAsEnum value
     */
    public EnumConst constStringAsEnum() {
        return this.constStringAsEnum;
    }

    /**
     * Set the constStringAsEnum value.
     *
     * @param constStringAsEnum the constStringAsEnum value to set
     * @return the Product object itself.
     */
    public Product withConstStringAsEnum(EnumConst constStringAsEnum) {
        this.constStringAsEnum = constStringAsEnum;
        return this;
    }

}
